<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>

    <!-- icon-top -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>

    <v-row>
      <v-col cols="12" sm="3" md="3">
        <v-alert tile elevation="2" dark style="background-color:#28a745">
          <p style="text-align:center">
            <span
              style="font-size:30px"
              v-if="data_dashborad.limit_film != 'unlimited'"
              ><B>{{ limit_film }}</B></span
            >

            <span style="font-size:30px" v-else><B>Unlimited</B></span>
            <br />
            <B> Limit Film</B>
          </p>
        </v-alert>
      </v-col>

      <v-col cols="12" sm="3" md="3">
        <v-alert tile elevation="2" dark style="background-color:#ffc107">
          <p style="text-align:center">
            <span
              style="font-size:30px"
              v-if="data_dashborad.limit_film != 'unlimited'"
              ><B>
                {{ balance_film }}
              </B>
            </span>

            <span style="font-size:30px" v-else><B>Unlimited</B></span>
            <br />
            <B> Balance Film</B>
          </p>
        </v-alert>
      </v-col>

      <v-col cols="12" sm="3" md="3">
        <v-alert border="top" tile colored-border color="primary" elevation="2">
          <p style="text-align:center">
            <span style="font-size:30px">
              <v-icon style="font-size:30px">mdi-arrow-up-thick</v-icon>
              <B> {{ use_film }} </B>
            </span>
            <br />
            Used Film
          </p>
        </v-alert>
      </v-col>

      <v-col cols="12" sm="3" md="3">
        <v-alert border="top" tile colored-border color="red" elevation="2">
          <p
            style="text-align:center"
            v-if="data_dashborad.limit_film != 'unlimited'"
          >
            <span style="font-size:30px">
              <v-icon style="font-size:30px" color="red"
                >mdi-arrow-down-thick</v-icon
              >
              {{ overfilm }}
            </span>
            <br />
            Over Film
          </p>

          <p style="text-align:center" v-else>
            <span style="font-size:30px">
              <v-icon style="font-size:30px" color="red"
                >mdi-arrow-down-thick</v-icon
              >
              Unlimited
            </span>
            <br />
            Over Film
          </p>
        </v-alert>
      </v-col>
    </v-row>

    <!-- table dashboard -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <!-- <v-card class="block bg"> -->
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title>
                  <h1>
                    Dashboard
                  </h1>
                </v-card-title>
                <div>
                  <v-card-title>
                    <v-row>
                      <v-col cols="6" sm="6" md="6" class="mt-2">
                        <v-dialog
                          ref="dialog"
                          v-model="modal_date"
                          :return-value.sync="select_date"
                          persistent
                          width="290px"
                        >
                          <template v-slot:activator="{ on, attrs }">
                            <v-text-field
                              v-model="select_date"
                              label="Select month Select year"
                              prepend-icon="mdi-calendar"
                              readonly
                              v-bind="attrs"
                              v-on="on"
                              dense
                              outlined
                            ></v-text-field>
                          </template>
                          <v-date-picker
                            v-model="select_date"
                            type="month"
                            scrollable
                          >
                            <v-spacer></v-spacer>
                            <v-btn
                              text
                              color="primary"
                              @click="modal_date = false"
                            >
                              Cancel
                            </v-btn>
                            <v-btn
                              text
                              color="primary"
                              @click="filter_date(select_date)"
                            >
                              OK
                            </v-btn>
                          </v-date-picker>
                        </v-dialog>
                      </v-col>

                      <v-col
                        cols="1"
                        sm="1"
                        md="1"
                        class="mt-6 pa-0"
                        style="cursor: pointer;"
                      >
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-icon
                              color="#FDD835"
                              v-bind="attrs"
                              v-on="on"
                              @click="reset_filter"
                              >mdi-backup-restore</v-icon
                            >
                          </template>
                          <span>reset</span></v-tooltip
                        >
                      </v-col>

                      <v-col cols="5" sm="5" md="5" class="mt-2">
                        <v-text-field
                          v-model="search"
                          append-icon="mdi-magnify"
                          label="Search"
                          dense
                          outlined
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-card-title>
                  <v-data-table
                    :headers="headers"
                    :items="select_all_dashboard"
                    :search="search"
                    :footer-props="{
                      'items-per-page-options': [10, 20, 50, 100]
                    }"
                  >
                    <template v-slot:item.status_wait="{ item }">
                      <span
                        v-if="item.status_wait == 'success'"
                        style="color:teal"
                        >Success</span
                      >
                      <!-- <v-icon v-if="item.status_wait == 'success'" color="teal">
                        mdi-check
                      </v-icon> -->
                      <!-- <v-icon v-else color="error"></v-icon> -->
                      <span v-else style="color:red">Fail</span>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table dashboard -->

    <!-- dialog_view_package -->
    <v-dialog v-model="dialog_view_package" max-width="500px">
      <v-card>
        <v-card-title class="headline" style="color:white;background:#37AABF">
          Package โรงพยาบาล Inet
        </v-card-title>
        <v-form ref="form_view_package">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_view_package.package_name"
                    label="Package"
                    disabled
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_view_package.package_price"
                    label="Package Price"
                    disabled
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_view_package.limit_film"
                    label="Limit Film"
                    disabled
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_view_package.balance"
                    label="Balance Film"
                    disabled
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_view_package.used_film"
                    label="Used Film"
                    disabled
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_view_package.over_film"
                    label="Over Film"
                    disabled
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="blue"
            @click="dialog_view_package = false"
            style="color: white;"
            >OK</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_view_package -->
  </v-app>
</template>

<script>
import moment from "moment";

export default {
  name: "Dashboard",
  data() {
    return {
      api: "https://1ls.manageai.co.th",
      // api: "https://1ls-demo.manageai.co.th",
      // api: "http://localhost:8080",
      fab: false,
      select_date: null,
      menu_date: false,
      modal_date: false,

      balance_film: 0,
      limit_film: 0,
      overfilm: 0,
      use_film: 0,
      data_dashborad: "",
      percentage_balance_film: "",
      percentage_used_film: "",
      dialog_loader: false,
      dialog_view_package: false,
      search: "",
      headers: [
        {
          text: "Username",
          align: "start",
          value: "username",
          sortable: false
        },
        {
          text: "Filename",
          align: "start",
          value: "old_filename",
          sortable: false
        },
        {
          text: "Action",
          align: "start",
          value: "action",
          sortable: false
        },
        {
          text: "Timstamp",
          align: "start",
          value: "upload_datetime",
          sortable: false,
          filter: this.filterMonths
        },
        {
          text: "Status",
          align: "start",
          value: "status_wait",
          sortable: false
        }
      ],
      all_dashboard: [],
      select_all_dashboard: [],
      form_view_package: {
        package_name: "Package_300",
        package_price: "1800",
        limit_film: "300",
        balance: "0",
        used_film: "1178",
        over_film: "878"
      }
    };
  },
  mounted() {
    console.log(this.$cookies.get("info_login").user_id);
    this.get_dashboard();
  },
  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    filter_date(select_date) {
      var date = moment(select_date).format("MMMM YYYY");
      this.select_all_dashboard = [];
      this.use_film = 0;
      for (
        let index = 0;
        index < this.data_dashborad.dashborad.length;
        index++
      ) {
        if (
          this.data_dashborad.dashborad[index].upload_datetime.match(date) !=
          null
        ) {
          this.limit_film = this.data_dashborad.limit_film;
          this.use_film = this.use_film + 1;
          this.balance_film = this.limit_film - this.use_film;
          this.select_all_dashboard.push(this.all_dashboard[index]);
          if (this.use_film > this.limit_film) {
            this.overfilm = this.use_film - this.limit_film;
            this.balance_film = 0;
          } else {
            this.overfilm = 0;
          }
        }
      }
      if (this.select_all_dashboard.length == 0) {
        this.select_all_dashboard = [];
        this.limit_film = 0;
        this.balance_film = 0;
        this.use_film = 0;
        this.overfilm = 0;
      }
      this.$refs.dialog.save(select_date);
      this.modal_date = false;
    },
    reset_filter() {
      this.select_all_dashboard = this.all_dashboard;
      this.limit_film = this.data_dashborad.limit_film * 12;
      this.balance_film =
        this.data_dashborad.limit_film * 12 - this.data_dashborad.use_film;
      this.use_film = this.data_dashborad.use_film;
      if (this.data_dashborad.use_film > this.data_dashborad.limit_film * 12) {
        this.overfilm =
          this.data_dashborad.use_film - this.data_dashborad.limit_film * 12;
        this.balance_film = 0;
      } else {
        this.overfilm = 0;
      }
      this.select_date = null;
    },
    get_dashboard() {
      this.dialog_loader = true;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/film_overviewretina", {
          params: {
            hospital_id: this.$cookies.get("info_login").hospital_id,
            user_id: this.$cookies.get("info_login").user_id
          },
          headers: {
            Authorization: this.$cookies.get("info_login").session_id //the token is a variable which holds the token
          }
        })
        .then(response => {
          if (response.data.status == "fail") {
            this.$swal({
              icon: "error",
              title: "Error!",
              text: response.data.message,
              confirmButtonText: "OK",
              allowOutsideClick: false
            }).then(() => {
              window.location.href = this.api;
            });
          } else {
            console.log("response", response.data.data);
            this.dialog_loader = false;
            this.data_dashborad = response.data.data;
            this.balance_film =
              response.data.data.limit_film * 12 - response.data.data.use_film;
            this.limit_film = response.data.data.limit_film * 12;
            this.overfilm = response.data.data.overfilm;
            this.use_film = response.data.data.use_film;
            if (
              response.data.data.use_film >
              response.data.data.limit_film * 12
            ) {
              this.overfilm =
                response.data.data.use_film -
                response.data.data.limit_film * 12;
              this.balance_film = 0;
            } else {
              this.overfilm = 0;
            }

            this.all_dashboard = response.data.data.dashborad;
            this.select_all_dashboard = this.all_dashboard;

            for (let index = 0; index < this.all_dashboard.length; index++) {
              this.all_dashboard[index].upload_datetime = moment(
                this.all_dashboard[index].upload_datetime
              ).format("DD MMMM YYYY hh:mm:ss");
            }

            return this.all_dashboard;
          }
        })
        .catch(error => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            this.dialog_loader = false;
            window.location.href = this.api;
          });
        });
    }
    // cal_percentage(){

    // }
  }
};
</script>

<style></style>
